Use case scenarios in EJ2 JavaScript Menu

21 Aug 202624 minutes to read

Scrollable menu

The menu component supports horizontal and vertical scrolling to render large menus and submenus in an adaptive way. This can be achieved by enabling the enableScrolling property and by restricting the corresponding menu/submenu size.

ej.base.enableRipple(true);

var menuItems = [
        {
            text: 'Appliances',
            items: [
                {
                    text: 'Kitchen',
                    items: [
                        { text: 'Electric Cookers' },
                        { text: 'Coffee Makers' },
                        { text: 'Blenders' },
                        { text: 'Microwave Ovens' }
                    ]
                },
                {
                    text: 'Television',
                    items: [
                        { text: 'Our Exclusive TVs' },
                        { text: 'Smart TVs' },
                        { text: 'Big Screen TVs' }
                    ]
                },
                {
                    text: 'Washing Machine'
                },
                {
                    text: 'Refrigerators'
                },
                {
                    text: 'Air Conditioners',
                    items: [
                        { text: 'Inverter ACs' },
                        { text: 'Split ACs' },
                        { text: 'Window ACs' },
                    ]
                },
                {
                    text: 'Water Purifiers'
                },
                {
                    text: 'Air Purifiers'
                },
                {
                    text: 'Chimneys'
                },
                {
                    text: 'Inverters'
                },
                {
                    text: 'Healthy Living'
                },
                {
                    text: 'Vacuum Cleaners'
                },
                {
                    text: 'Room Heaters'
                },
                {
                    text: 'New Launches'
                }
            ]
        },
        {
            text: 'Accessories',
            items: [
                {
                    text: 'Mobile',
                    items: [
                        { text: 'Headphones' },
                        { text: 'Memory Cards' },
                        { text: 'Power Banks' },
                        { text: 'Mobile Cases' },
                        { text: 'Screen Protectors' }
                    ]
                },
                {
                    text: 'Laptops'
                },
                {
                    text: 'Desktop PC',
                    items: [
                        { text: 'Pendrives' },
                        { text: 'External Hard Disks' },
                        { text: 'Monitors' },
                        { text: 'Keyboards' }
                    ]
                },
                {
                    text: 'Camera',
                    items: [
                        { text: 'Lens' },
                        { text: 'Tripods' }
                    ]
                }
            ]
        },
        {
            text: 'Fashion',
            items: [
                {
                    text: 'Men'
                },
                {
                    text: 'Women'
                }
            ]
        },
        {
            text: 'Home & Living',
            items: [
                {
                    text: 'Furniture'
                },
                {
                    text: 'Decor'
                },
                {
                    text: 'Smart Home Automation'
                },
                {
                    text: 'Dining & Serving'
                }
            ]
        },
        {
            text: 'Entertainment',
            items: [
                {
                    text: 'Televisions'
                },
                {
                    text: 'Home Theatres'
                },
                {
                    text: 'Gaming Laptops'
                }
            ]
        },
        {
            text: 'Contact Us'
        },
        {
            text: 'Help'
        }
    ];

var menuOptions = {
    items: menuItems,
    cssClass: 'e-scrollable-menu',
    enableScrolling: true,
    beforeOpen: function(args) {
        // Restricting sub menu wrapper height
        if (args.parentItem.text === 'Appliances') {
            ej.base.closest(args.element, '.e-menu-wrapper').style.height = '230px';
        }
    }
};

new ej.navigations.Menu(menuOptions, '#menu');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="control-section">
            <ul id="menu"></ul>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The following example demonstrates how to integrate Menu with Toolbar component.

var menuTemplate = '<ul id="menu"></ul>';

//Initialize Toolbar component
var toolbarObj = new ej.navigations.Toolbar({
    created: create,
    items: [
        { template: menuTemplate },
        { prefixIcon: 'em-icons e-shopping-cart', align: 'Right' }
    ]
}, '#shoppingtoolbar');

function create () {
    var data = [
        {
            header: 'Events',
            subItems: [
                { text: 'Conferences' },
                { text: 'Music' },
                { text: 'Workshops' }
            ]
        },
        {
            header: 'Movies',
            subItems: [
                { text: 'Now Showing' },
                { text: 'Coming Soon' }
            ]
        },
        {
            header: 'Directory',
            subItems: [
                { text: 'Media Gallery' },
                { text: 'Newsletters' }
            ]
        },
        {
            header: 'Queries',
            subItems: [
                { text: 'Our Policy' },
                { text: 'Site Map'},
                { text: '24x7 Support'}
            ]
        },
        { header: 'Services' }
    ];

    //Menu fields definition
    var menuFields = {
        text: ['header', 'text', 'value'],
        children: ['subItems', 'options']
    };

    //Initialize Menu component
    var menuObj = new ej.navigations.Menu({
        items: data,
        fields: menuFields,
        animationSettings: { effect: 'None' }
    }, '#menu');

    this.refreshOverflow();
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="control-section">
            <div class="toolbar-menu-control">
                <div id="shoppingtoolbar"></div>
            </div>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Hamburger menu

The following example demonstrates the use case of menu with Accordion component integrated in SideBar.

ej.base.enableRipple(true);

var acrdnObj;

// Sidebar Initialization
var defaultSidebar = new ej.navigations.Sidebar({
    width: '220px', type: 'Over', created: created
}, '#default-sidebar');

// Close the Sidebar
document.getElementById('close').onclick = function () {
    defaultSidebar.hide();
};

document.getElementById('hamburger').onclick = function () {
    defaultSidebar.show();
    acrdnObj.refresh();
};

function created() {
    var data = [
        {
            header: 'Appliances',
            content: '<div id="Appliances_Items"></div>',
            subItems: [
                {
                    header: 'Kitchen',
                    content: '<div id="Appliances_Kitchen_Items"></div>',
                    subItems: [
                        { header: 'Electric Cookers' },
                        { header: 'Coffee Makers' },
                        { header: 'Blenders' },
                    ]
                },
                {
                    header: 'Washing Machine',
                    content: '<div id="Appliances_Washing_Items"></div>',
                    subItems: [
                        { header: 'Fully Automatic' },
                        { header: 'Semi Automatic' }
                    ]
                },
                {
                    header: 'Air Conditioners',
                    content: '<div id="Appliances_Conditioners_Items"></div>',
                    subItems: [
                        { header: 'Inverter ACs' },
                        { header: 'Split ACs' },
                        { header: 'Window ACs' },
                    ]
                }
            ]
        },
        {
            header: 'Accessories',
            content: '<div id="Accessories_Items"></div>',
            subItems: [
                {
                    header: 'Mobile',
                    content: '<div id="Accessories_Mobile_Items"></div>',
                    subItems: [
                        { header: 'Headphones' },
                        { header: 'Memory Cards' },
                        { header: 'Power Banks' }
                    ]
                },
                {
                    header: 'Computer',
                    content: '<div id="Accessories_Computer_Items"></div>',
                    subItems: [
                        { header: 'Pendrives' },
                        { header: 'External Hard Disks' },
                        { header: 'Monitors' }
                    ]
                }
            ]
        },
        {
            header: 'Fashion',
            content: '<div id="Fashion_Items"></div>',
            subItems: [
                { header: 'Men' },
                { header: 'Women' }
            ]
        },
        {
            header: 'Home & Living',
            content: '<div id="Home_Living_Items"></div>',
            subItems: [
                { header: 'Furniture' },
                { header: 'Decor'}
            ]
        },
        {
            header: 'Entertainment',
            content: '<div id="Entertainment_Items"></div>',
            subItems: [
                { header: 'Televisions' },
                { header: 'Home Theatres' },
                { header: 'Gaming Laptops' }
            ]
        }
    ];

    //Initialize Accordion component
    acrdnObj = new ej.navigations.Accordion({
        items: data,
        expanding: expand,
        clicked: clicked
    }, '#accordionMenu');
}

//Expanding Event function for Accordion component.
function expand(e) {
    if (e.isExpanded) {
        if (e.element.getElementsByClassName('e-acrdn-content')[0].children[0].classList.contains('e-accordion')) {
            return;
        }
        //Initialize Nested Accordion component
        var nestAcrdn = new ej.navigations.Accordion({
            items: e.item.subItems,
            expanding: expand,
            clicked: clicked
        });

        var elemId = e.element.getElementsByClassName('e-acrdn-content')[0].children[0].id;
        //Render initialized Nested Accordion component
        nestAcrdn.appendTo('#' + elemId);
    }
}

function clicked(e) {
    if (!e.item && !(e.originalEvent.target).closest('.e-acrdn-item').getElementsByClassName('e-tgl-collapse-icon').length) {
        defaultSidebar.hide();
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
         <!-- sidebar element declaration -->
    <div class="header">
        <span id="hamburger" class="e-icons menu default"></span>
            <div class="content">Header content</div>
        </div>
        <aside id="default-sidebar">
            <div class="title-header">
                <div style="display:inline-block"> Menu </div>
                <span id="close" class="e-icons"></span>
            </div>
            <div class="content-area">
                <!--Accordion control declaration-->
                <div id="accordionMenu"></div>
            </div>
        </aside>
        <!-- main content declaration -->
        <div>
            <div class="main-content">Main content</div>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Mobile view

The following example demonstrates the use case of Menu in Mobile mode by using ListView component with hamburger.

ej.base.enableRipple(true);

// Initialize ListView data
var dataSource = [
    {
        text: 'Appliances',
        id: 'list1',
        child: [
            {
                text: 'Kitchen',
                id: 'list1_1',
                child: [
                    { id: 'list1_1_1', text: 'Electric Cookers' },
                    { id: 'list1_1_2', text: 'Coffee Makers' },
                    { id: 'list1_1_3', text: 'Blenders' },
                ]
            },
            {
                text: 'Washing Machine',
                id: 'list1_2',
                child: [
                    { id: 'list1_2_1', text: 'Fully Automatic' },
                    { id: 'list1_2_2', text: 'Semi Automatic' }
                ]
            },
            {
                text: 'Air Conditioners',
                id: 'list1_3',
                child: [
                    { id: 'list1_3_1', text: 'Inverter ACs' },
                    { id: 'list1_3_2', text: 'Split ACs' },
                    { id: 'list1_3_3', text: 'Window ACs' },
                ]
            }
        ]
    },
    {
        text: 'Accessories',
        id: 'list2',
        child: [
            {
                text: 'Mobile',
                id: 'list2_1',
                child: [
                    { id: 'list2_1_1', text: 'Headphones' },
                    { id: 'list2_1_2', text: 'Memory Cards' },
                    { id: 'list2_1_3', text: 'Power Banks' }
                ]
            },
            {
                text: 'Computer',
                id: 'list2_2',
                child: [
                    { id: 'list2_2_1', text: 'Pendrives' },
                    { id: 'list2_2_2', text: 'External Hard Disks' },
                    { id: 'list2_2_3', text: 'Monitors' }
                ]
            }
        ]
    },
    {
        text: 'Fashion',
        id: 'list3',
        child: [
            { id: 'list3_1', text: 'Men' },
            { id: 'list3_2', text: 'Women' }
        ]
    },
    {
        text: 'Home & Living',
        id: 'list4',
        child: [
            { id: 'list4_1', text: 'Furniture' },
            { id: 'list4_2', text: 'Decor'}
        ]
    },
    {
        text: 'Entertainment',
        id: 'list5',
        child: [
            { id: 'list5_1', text: 'Televisions' },
            { id: 'list5_2', text: 'Home Theatres' },
            { id: 'list5_3', text: 'Gaming Laptops' }
        ]
    }
];

//Initialize ListView component
var listObj = new ej.lists.ListView({

    //Set defined data to dataSource property
    dataSource: dataSource,

    //Set header title
    headerTitle: 'Menu',

    //Set true to show header title
    showHeader: true,

    select: onSelect
});

//Render initialized ListView component
listObj.appendTo('#listview');

document.getElementById('hamburger').onclick = function () {
    var animation = new ej.base.Animation({ duration: 500 });
    animation.animate(listObj.element, {
        name: 'SlideDown' ,
        begin: function(args) {
            listObj.element.style.display = 'block';
            document.getElementById('close').style.display = 'block';
        }
    });
};

// Close the ListView
document.getElementById('close').onclick = function () {
    listObj.element.style.display = 'none';
    document.getElementById('close').style.display = 'none';
};

function onSelect (e) {
    if (e.data && !e.data.child) {
        listObj.element.style.display = 'none';
        document.getElementById('close').style.display = 'none';
        listObj.refresh();
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="layoutWrapper">
            <div class="speaker">
                <div class="camera"></div>
            </div>
            <div class="layout">
                <div id="container">
                    <div id="header">
                        <span id="hamburger" class="e-icons menu default"></span>
                        <div class="content">Header</div>
                    </div>
                    <!-- ListView element -->
                    <div id="listview" tabindex="1" style="display: none;"></div>
                    <span id="close" class="e-icons" style="display: none;"></span>
                </div>
            </div>
            <div class="outerButton"> </div>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Use case scenarios in React Menu component

13 Apr 202624 minutes to read

Scrollable menu

The menu component supports horizontal and vertical scrolling to render large menus and submenus in an adaptive way. This can be achieved by enabling the enableScrolling property and by restricting the corresponding menu/submenu size.

import { closest, enableRipple } from '@syncfusion/ej2-base';
import { BeforeOpenCloseMenuEventArgs, MenuComponent, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    // Menu items definition
    let menuItems: MenuItemModel[] = [
        {
            items: [
                {
                    items: [
                        { text: 'Electric Cookers' },
                        { text: 'Coffee Makers' },
                        { text: 'Blenders' },
                        { text: 'Microwave Ovens' }
                    ],
                    text: 'Kitchen'
                },
                {
                    items: [
                        { text: 'Our Exclusive TVs' },
                        { text: 'Smart TVs' },
                        { text: 'Big Screen TVs' }
                    ],
                    text: 'Television'
                },
                {
                    text: 'Washing Machine'
                },
                {
                    text: 'Refrigerators'
                },
                {
                    items: [
                        { text: 'Inverter ACs' },
                        { text: 'Split ACs' },
                        { text: 'Window ACs' },
                    ],
                    text: 'Air Conditioners'
                },
                {
                    text: 'Water Purifiers'
                },
                {
                    text: 'Air Purifiers'
                },
                {
                    text: 'Chimneys'
                },
                {
                    text: 'Inverters'
                },
                {
                    text: 'Healthy Living'
                },
                {
                    text: 'Vacuum Cleaners'
                },
                {
                    text: 'Room Heaters'
                },
                {
                    text: 'New Launches'
                }
            ],
            text: 'Appliances'
        },
        {
            items: [
                {
                    items: [
                        { text: 'Headphones' },
                        { text: 'Memory Cards' },
                        { text: 'Power Banks' },
                        { text: 'Mobile Cases' },
                        { text: 'Screen Protectors' }
                    ],
                     text: 'Mobile'
                },
                {
                    text: 'Laptops'
                },
                {
                    items: [
                        { text: 'Pendrives' },
                        { text: 'External Hard Disks' },
                        { text: 'Monitors' },
                        { text: 'Keyboards' }
                    ],
                    text: 'Desktop PC'
                },
                {
                    items: [
                        { text: 'Lens' },
                        { text: 'Tripods' }
                    ],
                    text: 'Camera'
                }
            ],
            text: 'Accessories'
        },
        {
            items: [
                {
                    text: 'Men'
                },
                {
                    text: 'Women'
                }
            ],
             text: 'Fashion'
        },
        {
            items: [
                {
                    text: 'Furniture'
                },
                {
                    text: 'Decor'
                },
                {
                    text: 'Smart Home Automation'
                },
                {
                    text: 'Dining & Serving'
                }
            ],
            text: 'Home & Living'
        },
        {
            items: [
                {
                    text: 'Televisions'
                },
                {
                    text: 'Home Theatres'
                },
                {
                    text: 'Gaming Laptops'
                }
            ],
             text: 'Entertainment'
        },
        {
            text: 'Contact Us'
        },
        {
            text: 'Help'
        }
    ];

    function onBeforeOpen(args: BeforeOpenCloseMenuEventArgs) {
        // Restricting sub menu wrapper height
        if (args.parentItem.text === 'Appliances') {
            (closest(args.element, '.e-menu-wrapper') as HTMLElement).style.height = '230px';
        }
    }

    return (
        <MenuComponent items={menuItems} cssClass='e-scrollable-menu' enableScrolling={true} beforeOpen={onBeforeOpen}/>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

The following example demonstrates how to integrate Menu with Toolbar component.

import { enableRipple } from '@syncfusion/ej2-base';
import { ItemDirective, ItemsDirective, MenuComponent, ToolbarComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let tbObj;
    // Menu items definition
    let data = [
        {
            header: 'Events',
            subItems: [
                { text: 'Conferences' },
                { text: 'Music' },
                { text: 'Workshops' }
            ]
        },
        {
            header: 'Movies',
            subItems: [
                { text: 'Now Showing' },
                { text: 'Coming Soon' }
            ]
        },
        {
            header: 'Directory',
            subItems: [
                { text: 'Media Gallery' },
                { text: 'Newsletters' }
            ]
        },
        {
            header: 'Queries',
            subItems: [
                { text: 'Our Policy' },
                { text: 'Site Map' },
                { text: '24x7 Support' }
            ]
        },
        { header: 'Services' }
    ];
    let menuFields = {
        children: ['subItems', 'options'],
        text: ['header', 'text', 'value']
    };
    let animation = { effect: 'None' };
    function menuTemplate() {
        return (<MenuComponent id="menu" items={data} fields={menuFields} animationSettings={animation}/>);
    }
    function onCreated() {
        tbObj.refreshOverflow();
    }
    return (<div className="toolbar-menu-control">
            <ToolbarComponent id="toolbar" created={onCreated} ref={(scope) => { tbObj = scope; }}>
                <ItemsDirective>
                    <ItemDirective template={menuTemplate}/>
                    <ItemDirective prefixIcon='em-icons e-shopping-cart' align='Right'/>
                </ItemsDirective>
            </ToolbarComponent>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel, ItemDirective, ItemsDirective, MenuComponent, ToolbarComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    let tbObj: ToolbarComponent;

    // Menu items definition
    let data: Array<{[key: string]: any }> = [
        {
            header: 'Events',
            subItems: [
                { text: 'Conferences' },
                { text: 'Music' },
                { text: 'Workshops' }
            ]
        },
        {
            header: 'Movies',
            subItems: [
                { text: 'Now Showing' },
                { text: 'Coming Soon' }
            ]
        },
        {
            header: 'Directory',
            subItems: [
                { text: 'Media Gallery' },
                { text: 'Newsletters' }
            ]
        },
        {
            header: 'Queries',
            subItems: [
                { text: 'Our Policy' },
                { text: 'Site Map'},
                { text: '24x7 Support'}
            ]
        },
        { header: 'Services' }
    ];

    let menuFields: FieldSettingsModel = {
        children: ['subItems', 'options'],
        text: ['header', 'text', 'value']
    };

    let animation: any = { effect: 'None' };

    function menuTemplate(): JSX.Element {
        return (
            <MenuComponent id="menu" items={data} fields={menuFields} animationSettings={animation} />
        );
    }

    function onCreated(): void {
        tbObj.refreshOverflow();
    }

    return (
        <div className="toolbar-menu-control">
            <ToolbarComponent id="toolbar" created={onCreated} ref={(scope) => { tbObj = scope as ToolbarComponent; }} >
                <ItemsDirective>
                    <ItemDirective template={menuTemplate} />
                    <ItemDirective prefixIcon='em-icons e-shopping-cart' align='Right' />
                </ItemsDirective>
            </ToolbarComponent>
        </div>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

Hamburger menu

The following example demonstrates the use case of menu with Accordion component integrated in SideBar.

import { enableRipple } from '@syncfusion/ej2-base';
import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective, SidebarComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let sidebarObj;
    let accordionObj;
    let nestedAccordionObj;

    let width = '200px';
    let type = 'Over';

    function clicked(e) {
        const target = (e.originalEvent).target;
        if (!e.item && !(target.closest('.e-acrdn-item')).getElementsByClassName('e-tgl-collapse-icon').length) {
            sidebarObj.hide();
        }
    }

    function appliancesAccordion() {
        return ReactDom.render(
            <AccordionComponent ref={scope => nestedAccordionObj = scope} expanding={nestedExpand} clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Kitchen' content='<div id="Appliances_Kitchen_Items"></div>' />
                    <AccordionItemDirective header='Washing Machine' content='<div id="Appliances_Washing_Items"></div>' />
                    <AccordionItemDirective header='Air Conditioners' content='<div id="Appliances_Conditioners_Items"></div>' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Items"));
    }

    function kitchenAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Electric Cookers' />
                    <AccordionItemDirective header='Coffee Makers' />
                    <AccordionItemDirective header='Blenders' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Kitchen_Items"));
    }

    function acAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Inverter ACs' />
                    <AccordionItemDirective header='Split ACs' />
                    <AccordionItemDirective header='Window ACs' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Conditioners_Items"));
    }

    function washingAccordian() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Fully Automatic' />
                    <AccordionItemDirective header='Semi Automatic' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Washing_Items"));
    }

    function accessoriesAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Mobile' />
                    <AccordionItemDirective header='Computer' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Accessories_Items"));
    }

    function homeAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Furniture' />
                    <AccordionItemDirective header='Decor' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Home_Living_Items"));
    }

    function fashionAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Men' />
                    <AccordionItemDirective header='Women' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Fashion_Items"));
    }

    function entertainmentAccordion() {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Televisions' />
                    <AccordionItemDirective header='Home Theatres' />
                    <AccordionItemDirective header='Gaming Laptops' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Entertainment_Items"));
    }

    // Expanding Event function for main Accordion component.
    function expand(e) {
        if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 0) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            appliancesAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 1) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            accessoriesAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 2) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            fashionAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 3) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            homeAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 4) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            entertainmentAccordion();
        }
    }

    // Expanding Event function for nested Accordion component.
    function nestedExpand(e) {
        if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 0) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            kitchenAccordion();
        } else if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 1) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            washingAccordian();
        } else if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 2) {
            if ((e.element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            acAccordion();
        }
    }

    function hamburgerClick() {
        sidebarObj.show();
        accordionObj.refresh();
    }

    function close() {
        sidebarObj.hide();
    }

    return (
        <div>
            <div className="header">
                <span id="hamburger" className="e-icons menu default" onClick={hamburgerClick}/>
                <div className="content">Header content</div>
            </div>
            <SidebarComponent id='default-sidebar' width={width} type={type} ref={scope => sidebarObj = scope}>
                <div className="title-header">
                    <div style={{display:'inline-block'}}>Menu</div>
                    <span  id="close" className="e-icons" onClick={close}/>
                </div>
                <div className="content-area">
                    <AccordionComponent ref={scope => accordionObj = scope} expanding={expand} clicked={clicked}>
                        <AccordionItemsDirective>
                            <AccordionItemDirective header='Appliances' content='<div id="Appliances_Items"></div>' />
                            <AccordionItemDirective header='Accessories' content='<div id="Accessories_Items"></div>' />
                            <AccordionItemDirective header='Fashion' content='<div id="Fashion_Items"></div>' />
                            <AccordionItemDirective header='Home & Living' content='<div id="Home_Living_Items"></div>' />
                            <AccordionItemDirective header='Entertainment' content='<div id="Entertainment_Items"></div>' />
                        </AccordionItemsDirective>
                    </AccordionComponent>
                </div>
            </SidebarComponent>
            <div>
                <div className="main-content">Main content</div>
            </div>
        </div>
    );
}
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { AccordionClickArgs, AccordionComponent, AccordionItemDirective, AccordionItemsDirective, ExpandEventArgs, SidebarComponent, SidebarType } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    let sidebarObj: SidebarComponent;
    let accordionObj: AccordionComponent;
    let nestedAccordionObj: AccordionComponent;

    let width: string = '200px';
    let type: SidebarType = 'Over';

    function clicked(e: AccordionClickArgs): void {
        const target = (e.originalEvent as Event).target as HTMLElement;
        if (!e.item && !(target.closest('.e-acrdn-item') as HTMLElement).getElementsByClassName('e-tgl-collapse-icon').length) {
            sidebarObj.hide();
        }
    }

    function appliancesAccordion(): void {
        return ReactDom.render(
            <AccordionComponent ref={scope => nestedAccordionObj = scope as AccordionComponent} expanding={nestedExpand} clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Kitchen' content='<div id="Appliances_Kitchen_Items"></div>' />
                    <AccordionItemDirective header='Washing Machine' content='<div id="Appliances_Washing_Items"></div>' />
                    <AccordionItemDirective header='Air Conditioners' content='<div id="Appliances_Conditioners_Items"></div>' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Items"));
    }

    function kitchenAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Electric Cookers' />
                    <AccordionItemDirective header='Coffee Makers' />
                    <AccordionItemDirective header='Blenders' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Kitchen_Items"));
    }

    function acAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Inverter ACs' />
                    <AccordionItemDirective header='Split ACs' />
                    <AccordionItemDirective header='Window ACs' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Conditioners_Items"));
    }

    function washingAccordian(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Fully Automatic' />
                    <AccordionItemDirective header='Semi Automatic' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Appliances_Washing_Items"));
    }

    function accessoriesAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Mobile' />
                    <AccordionItemDirective header='Computer' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Accessories_Items"));
    }

    function homeAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Furniture' />
                    <AccordionItemDirective header='Decor' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Home_Living_Items"));
    }

    function fashionAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Men' />
                    <AccordionItemDirective header='Women' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Fashion_Items"));
    }

    function entertainmentAccordion(): void {
        return ReactDom.render(
            <AccordionComponent clicked={clicked}>
                <AccordionItemsDirective>
                    <AccordionItemDirective header='Televisions' />
                    <AccordionItemDirective header='Home Theatres' />
                    <AccordionItemDirective header='Gaming Laptops' />
                </AccordionItemsDirective>
            </AccordionComponent>,
            document.getElementById("Entertainment_Items"));
    }

    // Expanding Event function for main Accordion component.
    function expand(e: ExpandEventArgs): void {
        if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 0) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            appliancesAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 1) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            accessoriesAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 2) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            fashionAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 3) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            homeAccordion();
        } else if (e.isExpanded && [].indexOf.call(accordionObj.items, e.item) === 4) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            entertainmentAccordion();
        }
    }

    // Expanding Event function for nested Accordion component.
    function nestedExpand(e: ExpandEventArgs): void {
        if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 0) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            kitchenAccordion();
        } else if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 1) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            washingAccordian();
        } else if (e.isExpanded && [].indexOf.call(nestedAccordionObj.items, e.item) === 2) {
            if ((e.element as Element).querySelectorAll('.e-accordion').length > 0) {
                return;
            }
            acAccordion();
        }
    }

    function hamburgerClick(): void {
        sidebarObj.show();
        accordionObj.refresh();
    }

    function close(): void {
        sidebarObj.hide();
    }

    return (
        <div>
            <div className="header">
                <span id="hamburger" className="e-icons menu default" onClick={hamburgerClick}/>
                <div className="content">Header content</div>
            </div>
            <SidebarComponent id='default-sidebar' width={width} type={type} ref={scope => sidebarObj = scope as SidebarComponent}>
                <div className="title-header">
                    <div style={{display:'inline-block'}}>Menu</div>
                    <span  id="close" className="e-icons" onClick={close}/>
                </div>
                <div className="content-area">
                    <AccordionComponent ref={scope => accordionObj = scope as AccordionComponent} expanding={expand} clicked={clicked}>
                        <AccordionItemsDirective>
                            <AccordionItemDirective header='Appliances' content='<div id="Appliances_Items"></div>' />
                            <AccordionItemDirective header='Accessories' content='<div id="Accessories_Items"></div>' />
                            <AccordionItemDirective header='Fashion' content='<div id="Fashion_Items"></div>' />
                            <AccordionItemDirective header='Home & Living' content='<div id="Home_Living_Items"></div>' />
                            <AccordionItemDirective header='Entertainment' content='<div id="Entertainment_Items"></div>' />
                        </AccordionItemsDirective>
                    </AccordionComponent>
                </div>
            </SidebarComponent>
            <div>
                <div className="main-content">Main content</div>
            </div>
        </div>
    );
}

ReactDom.render(<App />,document.getElementById('element'));

Mobile view

The following example demonstrates the use case of Menu in Mobile mode by using ListView component with hamburger.

import { Animation, enableRipple } from '@syncfusion/ej2-base';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let listObj;
    let listViewDisplay = { display: 'none' };
    let closeSpanDisplay = { display: 'none' };
    let dataSource = [
        {
            child: [
                {
                    child: [
                        { id: 'list1_1_1', text: 'Electric Cookers' },
                        { id: 'list1_1_2', text: 'Coffee Makers' },
                        { id: 'list1_1_3', text: 'Blenders' },
                    ],
                    id: 'list1_1',
                    text: 'Kitchen'
                },
                {
                    child: [
                        { id: 'list1_2_1', text: 'Fully Automatic' },
                        { id: 'list1_2_2', text: 'Semi Automatic' }
                    ],
                    id: 'list1_2',
                    text: 'Washing Machine'
                },
                {
                    child: [
                        { id: 'list1_3_1', text: 'Inverter ACs' },
                        { id: 'list1_3_2', text: 'Split ACs' },
                        { id: 'list1_3_3', text: 'Window ACs' },
                    ],
                    id: 'list1_3',
                    text: 'Air Conditioners'
                }
            ],
            id: 'list1',
            text: 'Appliances'
        },
        {
            child: [
                {
                    child: [
                        { id: 'list2_1_1', text: 'Headphones' },
                        { id: 'list2_1_2', text: 'Memory Cards' },
                        { id: 'list2_1_3', text: 'Power Banks' }
                    ],
                    id: 'list2_1',
                    text: 'Mobile'
                },
                {
                    child: [
                        { id: 'list2_2_1', text: 'Pendrives' },
                        { id: 'list2_2_2', text: 'External Hard Disks' },
                        { id: 'list2_2_3', text: 'Monitors' }
                    ],
                    id: 'list2_2',
                    text: 'Computer'
                }
            ],
            id: 'list2',
            text: 'Accessories'
        },
        {
            child: [
                { id: 'list3_1', text: 'Men' },
                { id: 'list3_2', text: 'Women' }
            ],
            id: 'list3',
            text: 'Fashion'
        },
        {
            child: [
                { id: 'list4_1', text: 'Furniture' },
                { id: 'list4_2', text: 'Decor' }
            ],
            id: 'list4',
            text: 'Home & Living'
        },
        {
            child: [
                { id: 'list5_1', text: 'Televisions' },
                { id: 'list5_2', text: 'Home Theatres' },
                { id: 'list5_3', text: 'Gaming Laptops' }
            ],
            id: 'list5',
            text: 'Entertainment'
        }
    ];
    function onSelect(e) {
        if (e.data && !e.data.child) {
            listViewDisplay = { display: 'none' };
            closeSpanDisplay = { display: 'none' };
            listObj.refresh();
        }
    }
    function onClick() {
        listViewDisplay = { display: 'none' };
        closeSpanDisplay = { display: 'none' };
    }
    function hamburgerClick() {
        const animation = new Animation({ duration: 500 });
        animation.animate(listObj.element, {
            begin: () => {
                listViewDisplay = { display: 'block' };
                closeSpanDisplay = { display: 'block' };
            },
            name: 'SlideDown'
        });
    }
    return (<div className='layoutWrapper'>
            <div className='speaker'>
                <div className='camera'/>
            </div>
            <div className='layout'>
                <div id='container'>
                    <div id='header'>
                        <span id='hamburger' onClick={hamburgerClick} className='e-icons menu default'/>
                        <div className='content'>Header</div>
                    </div>
                    <ListViewComponent id='listview' ref={scope => listObj = scope} dataSource={dataSource} showHeader={true} headerTitle='Menu' select={onSelect}/>
                    <span id='close' onClick={onClick} className='e-icons' style={closeSpanDisplay}/>
                </div>
            </div>
            <div className='outerButton'/>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { Animation, enableRipple } from '@syncfusion/ej2-base';
import { ListViewComponent, SelectEventArgs } from '@syncfusion/ej2-react-lists';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    let listObj: ListViewComponent;
    let listViewDisplay: any = { display: 'none' };
    let closeSpanDisplay: any = { display: 'none' };
    let dataSource: Array<{ [key: string]: any }> = [
        {
            child: [
            {
                child: [
                    { id: 'list1_1_1', text: 'Electric Cookers' },
                    { id: 'list1_1_2', text: 'Coffee Makers' },
                    { id: 'list1_1_3', text: 'Blenders' },
                ],
                id: 'list1_1',
                text: 'Kitchen'
            },
            {
                child: [
                    { id: 'list1_2_1', text: 'Fully Automatic' },
                    { id: 'list1_2_2', text: 'Semi Automatic' }
                ],
                id: 'list1_2',
                text: 'Washing Machine'
            },
            {
                child: [
                    { id: 'list1_3_1', text: 'Inverter ACs' },
                    { id: 'list1_3_2', text: 'Split ACs' },
                    { id: 'list1_3_3', text: 'Window ACs' },
                ],
                id: 'list1_3',
                text: 'Air Conditioners'
            }],
            id: 'list1',
            text: 'Appliances'
        },
        {
            child: [
            {
                child: [
                    { id: 'list2_1_1', text: 'Headphones' },
                    { id: 'list2_1_2', text: 'Memory Cards' },
                    { id: 'list2_1_3', text: 'Power Banks' }
                ],
                id: 'list2_1',
                text: 'Mobile'
            },
            {
                child: [
                    { id: 'list2_2_1', text: 'Pendrives' },
                    { id: 'list2_2_2', text: 'External Hard Disks' },
                    { id: 'list2_2_3', text: 'Monitors' }
                ],
                id: 'list2_2',
                text: 'Computer'
            }],
            id: 'list2',
            text: 'Accessories'
        },
        {
            child: [
                { id: 'list3_1', text: 'Men' },
                { id: 'list3_2', text: 'Women' }
            ],
            id: 'list3',
            text: 'Fashion'
        },
        {
            child: [
                { id: 'list4_1', text: 'Furniture' },
                { id: 'list4_2', text: 'Decor' }
            ],
            id: 'list4',
            text: 'Home & Living'
        },
        {
            child: [
                { id: 'list5_1', text: 'Televisions' },
                { id: 'list5_2', text: 'Home Theatres' },
                { id: 'list5_3', text: 'Gaming Laptops' }
            ],
            id: 'list5',
            text: 'Entertainment'
        }
    ];

    function onSelect(e: SelectEventArgs): void {
        if (e.data && !(e.data as { child: object }).child) {
            listViewDisplay = { display: 'none' };
            closeSpanDisplay = { display: 'none' };
            listObj.refresh();
        }
    }

    function onClick(): void {
        listViewDisplay = { display: 'none' };
        closeSpanDisplay = { display: 'none' };
    }

    function hamburgerClick(): void {
        const animation = new Animation({ duration: 500 });
        animation.animate(listObj.element, {
            begin: () => {
                listViewDisplay = { display: 'block' };
                closeSpanDisplay = { display: 'block' };
            },
            name: 'SlideDown'
        });
    }

    return (
        <div className='layoutWrapper'>
            <div className='speaker'>
                <div className='camera'/>
            </div>
            <div className='layout'>
                <div id='container'>
                    <div id='header'>
                        <span id='hamburger' onClick={hamburgerClick} className='e-icons menu default'/>
                        <div className='content'>Header</div>
                    </div>
                    <ListViewComponent id='listview' ref={scope => listObj = scope as ListViewComponent} dataSource={dataSource} showHeader={true} headerTitle='Menu' select={onSelect}/>
                    <span id='close' onClick={onClick} className='e-icons' style={closeSpanDisplay}/>
                </div>
            </div>
            <div className='outerButton'/>
        </div>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

Syncfusion AI Assistant

How can I help you?

Use case scenarios in Angular Menu component

12 Sep 202524 minutes to read

This section demonstrates practical use cases for the Angular Menu component, including scrollable menus, toolbar integration, hamburger menus, and mobile views.

Scrollable menu

The menu component supports horizontal and vertical scrolling to render large menus and submenus in an adaptive way. This can be achieved by enabling the enableScrolling property and by restricting the corresponding menu/submenu size.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule } from '@syncfusion/ej2-angular-navigations'



import { Component } from '@angular/core';
import { enableRipple, closest } from '@syncfusion/ej2-base';
import { MenuItemModel, BeforeOpenCloseMenuEventArgs } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

@Component({
imports: [ MenuModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
            <ejs-menu [items]='menuItems' cssClass='e-scrollable-menu' [enableScrolling]="true"  (beforeOpen)='onBeforeOpen($event)'></ejs-menu>
            </div>`
})

export class AppComponent {
    menuItems: MenuItemModel[] = [
        {
            text: 'Appliances',
            items: [
                {
                    text: 'Kitchen',
                    items: [
                        { text: 'Electric Cookers' },
                        { text: 'Coffee Makers' },
                        { text: 'Blenders' },
                        { text: 'Microwave Ovens' }
                    ]
                },
                {
                    text: 'Television',
                    items: [
                        { text: 'Our Exclusive TVs' },
                        { text: 'Smart TVs' },
                        { text: 'Big Screen TVs' }
                    ]
                },
                {
                    text: 'Washing Machine'
                },
                {
                    text: 'Refrigerators'
                },
                {
                    text: 'Air Conditioners',
                    items: [
                        { text: 'Inverter ACs' },
                        { text: 'Split ACs' },
                        { text: 'Window ACs' },
                    ]
                },
                {
                    text: 'Water Purifiers'
                },
                {
                    text: 'Air Purifiers'
                },
                {
                    text: 'Chimneys'
                },
                {
                    text: 'Inverters'
                },
                {
                    text: 'Healthy Living'
                },
                {
                    text: 'Vacuum Cleaners'
                },
                {
                    text: 'Room Heaters'
                },
                {
                    text: 'New Launches'
                }
            ]
        },
        {
            text: 'Accessories',
            items: [
                {
                    text: 'Mobile',
                    items: [
                        { text: 'Headphones' },
                        { text: 'Memory Cards' },
                        { text: 'Power Banks' },
                        { text: 'Mobile Cases' },
                        { text: 'Screen Protectors' }
                    ]
                },
                {
                    text: 'Laptops'
                },
                {
                    text: 'Desktop PC',
                    items: [
                        { text: 'Pendrives' },
                        { text: 'External Hard Disks' },
                        { text: 'Monitors' },
                        { text: 'Keyboards' }
                    ]
                },
                {
                    text: 'Camera',
                    items: [
                        { text: 'Lens' },
                        { text: 'Tripods' }
                    ]
                }
            ]
        },
        {
            text: 'Fashion',
            items: [
                {
                    text: 'Men'
                },
                {
                    text: 'Women'
                }
            ]
        },
        {
            text: 'Home & Living',
            items: [
                {
                    text: 'Furniture'
                },
                {
                    text: 'Decor'
                },
                {
                    text: 'Smart Home Automation'
                },
                {
                    text: 'Dining & Serving'
                }
            ]
        },
        {
            text: 'Entertainment',
            items: [
                {
                    text: 'Televisions'
                },
                {
                    text: 'Home Theatres'
                },
                {
                    text: 'Gaming Laptops'
                }
            ]
        },
        {
            text: 'Contact Us'
        },
        {
            text: 'Help'
        }
    ];

    onBeforeOpen(args: BeforeOpenCloseMenuEventArgs): void {
        // Restricting sub menu wrapper height
        if (args.parentItem.text === 'Appliances') {
            (closest(args.element, '.e-menu-wrapper') as HTMLElement).style.height = '230px';
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Building on the Menu component’s integration capabilities, the following example demonstrates how to integrate the Menu with the Toolbar component. Note that the ToolbarModule must be imported from @syncfusion/ej2-angular-navigations to use the Toolbar alongside the Menu.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule, ToolbarModule } from '@syncfusion/ej2-angular-navigations'



import { Component, ViewChild } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { ToolbarComponent, MenuAnimationSettingsModel } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

@Component({
imports: [ MenuModule, ToolbarModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
            <div class="control-section">
                 <div class="toolbar-menu-control">
                    <div id='menu'><ejs-menu [items]='menuItems' [fields]='menuFields' [animationSettings]='animationSettings'></ejs-menu></div>
                 <ejs-toolbar id="shoppingtoolbar" #toolbar (created)='created()'>
                    <e-items>
                        <e-item template='#menu'></e-item>
                        <e-item prefixIcon='em-icons e-shopping-cart' align='Right'></e-item>
                    </e-items>
                 </ejs-toolbar>
                </div>
               </div>
               </div>`
})

export class AppComponent {
    @ViewChild('toolbar')
    public toolbarObj?: ToolbarComponent;

    public menuItems: { [key: string]: Object }[] = [
        {
            header: 'Events',
            subItems: [
                { text: 'Conferences' },
                { text: 'Music' },
                { text: 'Workshops' }
            ]
        },
        {
            header: 'Movies',
            subItems: [
                { text: 'Now Showing' },
                { text: 'Coming Soon' }
            ]
        },
        {
            header: 'Directory',
            subItems: [
                { text: 'Media Gallery' },
                { text: 'Newsletters' }
            ]
        },
        {
            header: 'Queries',
            subItems: [
                { text: 'Our Policy' },
                { text: 'Site Map' },
                { text: '24x7 Support' }
            ]
        },
        { header: 'Services' }
    ];

    public menuFields: Object = {
        text: ['header', 'text', 'value'],
        children: ['subItems', 'options']
    };

    public animationSettings: MenuAnimationSettingsModel = { effect: 'None' };

    public created(): void {
        this.toolbarObj?.refreshOverflow();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Hamburger menu

The following example demonstrates a hamburger menu integrating the Menu component with the Accordion component within a SideBar, where the Accordion organizes menu items vertically and the SideBar provides a collapsible navigation panel.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SidebarModule, AccordionModule } from '@syncfusion/ej2-angular-navigations'



import { Component, ViewChild } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { Accordion } from '@syncfusion/ej2-navigations';
import { SidebarComponent, AccordionComponent, ExpandEventArgs, AccordionClickArgs } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

@Component({
imports: [ SidebarModule, AccordionModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
            <div class="header">
        <span id="hamburger" class="e-icons menu default" (click)='hamburgerClick()'></span>
            <div class="content">Header content</div>
        </div>
        <ejs-sidebar #sidebar id='default-sidebar' width='220px' type='Over'>
            <div class="title-header">
                <div style="display:inline-block"> Menu </div>
                <span  id="close" class="e-icons" (click)='close()'></span>
            </div>
            <div class="content-area">
                <ejs-accordion #accordion [items]='data' (expanding)='expand($event)' (clicked)='clicked($event)'></ejs-accordion>
            </div>
        </ejs-sidebar>
        <!-- main content declaration -->
        <div>
            <div class="main-content">Main content</div>
        </div>
        </div>`
})

export class AppComponent {
    @ViewChild('sidebar')
    public sidebarObj?: SidebarComponent;
    @ViewChild('accordion')
    public accordionObj?: AccordionComponent;

    public data: { [key: string]: Object }[] = [
        {
            header: 'Appliances',
            content: '<div id="Appliances_Items"></div>',
            subItems: [
                {
                    header: 'Kitchen',
                    content: '<div id="Appliances_Kitchen_Items"></div>',
                    subItems: [
                        { header: 'Electric Cookers' },
                        { header: 'Coffee Makers' },
                        { header: 'Blenders' },
                    ]
                },
                {
                    header: 'Washing Machine',
                    content: '<div id="Appliances_Washing_Items"></div>',
                    subItems: [
                        { header: 'Fully Automatic' },
                        { header: 'Semi Automatic' }
                    ]
                },
                {
                    header: 'Air Conditioners',
                    content: '<div id="Appliances_Conditioners_Items"></div>',
                    subItems: [
                        { header: 'Inverter ACs' },
                        { header: 'Split ACs' },
                        { header: 'Window ACs' },
                    ]
                }
            ]
        },
        {
            header: 'Accessories',
            content: '<div id="Accessories_Items"></div>',
            subItems: [
                {
                    header: 'Mobile',
                    content: '<div id="Accessories_Mobile_Items"></div>',
                    subItems: [
                        { header: 'Headphones' },
                        { header: 'Memory Cards' },
                        { header: 'Power Banks' }
                    ]
                },
                {
                    header: 'Computer',
                    content: '<div id="Accessories_Computer_Items"></div>',
                    subItems: [
                        { header: 'Pendrives' },
                        { header: 'External Hard Disks' },
                        { header: 'Monitors' }
                    ]
                }
            ]
        },
        {
            header: 'Fashion',
            content: '<div id="Fashion_Items"></div>',
            subItems: [
                { header: 'Men' },
                { header: 'Women' }
            ]
        },
        {
            header: 'Home & Living',
            content: '<div id="Home_Living_Items"></div>',
            subItems: [
                { header: 'Furniture' },
                { header: 'Decor' }
            ]
        },
        {
            header: 'Entertainment',
            content: '<div id="Entertainment_Items"></div>',
            subItems: [
                { header: 'Televisions' },
                { header: 'Home Theatres' },
                { header: 'Gaming Laptops' }
            ]
        }
    ];

    //Expanding Event function for Accordion component.
    public expand(e: ExpandEventArgs): void {
        if (e.isExpanded) {
            if ((e.element as HTMLElement).getElementsByClassName('e-acrdn-content')[0].children[0].classList.contains('e-accordion')) {
                return;
            }
            //Initialize Nested Accordion component
            let nestAcrdn: Accordion = new Accordion({
                items: (<{ subItems: object[] }>e.item).subItems,
                expanding: this.expand,
                clicked: this.clicked
            });

            let elemId: string = (e.element as HTMLElement).getElementsByClassName('e-acrdn-content')[0].children[0].id;
            //Render initialized Nested Accordion component
            nestAcrdn.appendTo('#' + elemId);
        }
    }

    public clicked(e: AccordionClickArgs): void {
        if (!e.item && !(((e.originalEvent as Event).target as HTMLElement).closest('.e-acrdn-item') as Element).getElementsByClassName('e-tgl-collapse-icon').length) {
            this.sidebarObj?.hide();
        }
    }

    public hamburgerClick(): void {
        this.sidebarObj?.show();
        (this.accordionObj as AccordionComponent).refresh();
    }

    public close(): void {
        this.sidebarObj?.hide();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Mobile view

The following example demonstrates the use case of the Menu in mobile mode using the ListView component with a hamburger icon.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ListViewModule } from '@syncfusion/ej2-angular-lists'



import { Component, ViewChild } from '@angular/core';
import { enableRipple, Animation, AnimationOptions } from '@syncfusion/ej2-base';
import { ListViewComponent, SelectEventArgs } from '@syncfusion/ej2-angular-lists';

enableRipple(true);

@Component({
imports: [ ListViewModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
      <div class="layoutWrapper">
            <div class="speaker">
                <div class="camera"></div>
            </div>
            <div class="layout">
                <div id="container">
                    <div id="header">
                        <span id="hamburger" (click)="hamburgerClick()" class="e-icons menu default"></span>
                        <div class="content">Header</div>
                    </div>
                    <!-- ListView element -->
                    <ejs-listview  id="listview" #listview [dataSource]="dataSource" headerTitle="Menu" [showHeader]="true" (select)="onSelect($event)" tabindex="1" [style.display]='listViewDisplay' ></ejs-listview>
                    <span id="close" (click)="onClick($event)" class="e-icons" [style.display]='closeSpanDisplay'></span>
                </div>
            </div>
            <div class="outerButton"> </div>
        </div>
        </div>`
})

export class AppComponent {
  @ViewChild('listview')
  public listObj?: ListViewComponent;
  public listViewDisplay: string = 'none';
  public closeSpanDisplay: string = 'none';

  public dataSource: { [key: string]: Object }[] = [
    {
      text: 'Appliances',
      id: 'list1',
      child: [
        {
          text: 'Kitchen',
          id: 'list1_1',
          child: [
            { id: 'list1_1_1', text: 'Electric Cookers' },
            { id: 'list1_1_2', text: 'Coffee Makers' },
            { id: 'list1_1_3', text: 'Blenders' },
          ]
        },
        {
          text: 'Washing Machine',
          id: 'list1_2',
          child: [
            { id: 'list1_2_1', text: 'Fully Automatic' },
            { id: 'list1_2_2', text: 'Semi Automatic' }
          ]
        },
        {
          text: 'Air Conditioners',
          id: 'list1_3',
          child: [
            { id: 'list1_3_1', text: 'Inverter ACs' },
            { id: 'list1_3_2', text: 'Split ACs' },
            { id: 'list1_3_3', text: 'Window ACs' },
          ]
        }
      ]
    },
    {
      text: 'Accessories',
      id: 'list2',
      child: [
        {
          text: 'Mobile',
          id: 'list2_1',
          child: [
            { id: 'list2_1_1', text: 'Headphones' },
            { id: 'list2_1_2', text: 'Memory Cards' },
            { id: 'list2_1_3', text: 'Power Banks' }
          ]
        },
        {
          text: 'Computer',
          id: 'list2_2',
          child: [
            { id: 'list2_2_1', text: 'Pendrives' },
            { id: 'list2_2_2', text: 'External Hard Disks' },
            { id: 'list2_2_3', text: 'Monitors' }
          ]
        }
      ]
    },
    {
      text: 'Fashion',
      id: 'list3',
      child: [
        { id: 'list3_1', text: 'Men' },
        { id: 'list3_2', text: 'Women' }
      ]
    },
    {
      text: 'Home & Living',
      id: 'list4',
      child: [
        { id: 'list4_1', text: 'Furniture' },
        { id: 'list4_2', text: 'Decor' }
      ]
    },
    {
      text: 'Entertainment',
      id: 'list5',
      child: [
        { id: 'list5_1', text: 'Televisions' },
        { id: 'list5_2', text: 'Home Theatres' },
        { id: 'list5_3', text: 'Gaming Laptops' }
      ]
    }
  ];

  public onSelect(e: SelectEventArgs): void {
    if (e.data && !(e.data as { child: object }).child) {
      this.listViewDisplay = 'none';
      this.closeSpanDisplay = 'none';
      this.listObj?.refresh();
    }
  }

  public onClick = (args: any): void => {
    this.listViewDisplay = 'none';
    this.closeSpanDisplay = 'none';
  };

  public hamburgerClick = () => {
    let animation: Animation = new Animation({ duration: 500 });
    animation.animate((this.listObj as ListViewComponent).element, {
      name: 'SlideDown',
      begin: (args: AnimationOptions) => {
        this.listViewDisplay = 'block';
        this.closeSpanDisplay = 'block';
      }
    });
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));